# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ YY-BOARD : init.cgi - 2021/07/24
#│ copyright (c) KentWeb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'YY-BOARD v10.2';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このプログラムはフリーソフトです。このプログラムを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  YY-BOARD v10.2 PLUS : init.cgi - 2021/07/24
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

#===========================================================
# ■ 設定項目
#===========================================================

# パスワード制限をする場合入室パスワード設定
# → 空欄の場合はパスワード制限なし
$cf{enter_pwd} = '0123';

# パスワード制限時のセッションの許容時間（分単位）
# → 入室後からアクセス可能時間
$cf{sestime} = 60;

# アップロードファイル管理者チェック機能 (0=no 1=yes)
# → アップロードファイルは管理者がチェック後表示
$cf{img_check} = 0;

# サムネイル画像を作成する（要：Image::Magick）
# → 縮小画像を自動生成し、画像記事の表示速度を軽くする機能
# 0=no 1=yes
$cf{thumbnail} = 0;

# 掲示板タイトル
$cf{bbs_title} = "掲示板 - $cf{version}";

# カウンタファイル【サーバパス】
$cf{cntfile} = './data/count.dat';

# 本体ファイル【URLパス】
$cf{bbs_cgi} = './yybbs.cgi';

# 更新ファイル【URLパス】
$cf{regist_cgi} = './regist.cgi';

# 管理ファイル【URLパス】
$cf{admin_cgi} = './admin.cgi';

# データファイル【サーバパス】
$cf{logfile} = './data/log.cgi';

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# セッションファイル【サーバパス】
$cf{sesfile} = './data/ses.cgi';

# テンプレートディレクトリ【サーバパス】
$cf{tmpldir} = './tmpl';

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# スタイルシート(スマホ用)ディレクトリ【URLパス】
$cf{mobcss} = './cmn/yybbs_mobile.css';

# 戻り先【URLパス】
$cf{homepage} = "../index.html";

# YouTubeを表示する
# $cf{tube} = 1; で固定とする
$cf{tube} = 1;

# 画像の位置
# 1 : コメントの下
# 2 : コメントの右（廻り込み）固定
$cf{image_position} = 2;

# アップロードディレクトリ【サーバパス】
$cf{upldir} = './upl';

# アップロードディレクトリ【URLパス】
$cf{uplurl} = "./upl";

# 最大記録記事数
$cf{max} = 100;

# アイコンディレクトリ【URLパス】
$cf{iconurl} = './cmn/face';

# アイコンモード機能
# 0 : アイコン不使用
# 1 : アイコン使用
$cf{icon_mode} = 1;

# アイコンを定義
# → 前にファイル名、後にアイコン名をコンマで区切る
$cf{icon} = [
	'itumodomo.gif,いつもどうも',
	'anpanti.gif,パンチ',
	'omaigot.gif,オーマイゴット',
	'suisugi.gif,一服',
	'tanonmas.gif,たのんます',
	'bitukuri.gif,ビツクリ',
	'kanpai.gif,乾杯',
	'kakikaki.gif,メモメモ',
	'tegami.gif,お手紙',
	'hanataba.gif,花束１',
	'eieio.gif,えいえいオゥ',
	'cat001.gif,ノーマル猫',
	'cat013.gif,嬉しい',
	'cat014.gif,わからない',
	'img03.gif,犬質問',
	'img04.gif,猫質問',
	'img05.gif,犬なるほど',
	'img06.gif,猫なるほど',
	'cnyan_02.gif,わぁ～い',
	'cnyan_05.gif,きゅぅ～ん',
	'cnyan_07.gif,ぷんぷん',
	'cnyan_12.gif,がくっ・・・',
	'cnyan_15.gif,あせあせ',
	'cnyan_18.gif,あっ・・・',
	'cnyan_19.gif,ずりっ',
	'cnyan_20.gif,ふれ～～',
	];

# ユーザーアイコン登録CGIのURL【URLパス】
$cf{icoreg_cgi} = './icoreg.cgi';

# ユーザーアイコン情報ログファイル【サーバパス】
$cf{iconfile} = './data/iconfile.cgi';

# ユーザーアイコン使用【サーバパス】
$cf{user_icon} = 1;

# 管理者専用アイコン機能 (0=no 1=yes)
# (使い方) 記事投稿時に「管理者アイコン」を選択し暗証キーに「管理者専用アイコン用パスワード」を入力して下さい。
$cf{my_icon} = 1;

# 管理者専用アイコン用パスワード
$cf{password} = '0123';

# 管理者専用アイコンの「ファイル名」を指定
$cf{my_gif}  = 'admin.gif';

# アイコン【URLパス】
# → 順に [ホームページ][Mail][クリップ][YouTube]
$cf{ico_home} = "./cmn/house.png";
$cf{ico_mail} = "./cmn/mail.png";
$cf{ico_clip} = "./cmn/clip.gif";
$cf{tube_ico} = "./cmn/tube_icon.png";

# 返信がつくと親記事をトップへ移動 (0=no 1=yes)
$cf{topsort} = 1;

# ミニカウンタの設置
# → 0=no 1=テキスト 2=画像
$cf{counter} = 1;

# ミニカウンタの桁数
$cf{mini_fig} = 6;

# テキストのとき：ミニカウンタの色
$cf{cntcol} = "#ffffff";

# 記事 [タイトル] 部の長さ (全角文字換算)
# これ以上に設定するとリボンの外にはみ出します
$cf{sub_len} = 40;

# １ページ当たりの記事表示数 (親記事)
# → 順に、スレッド表示、アルバム表示、登録アイコン
$cf{pg_max} = 5;
$cf{max_albums} = 8;
$cf{max_icon} = 6;

# → 残り90%でアラームを表示
# 返信数調整（変更推奨：↓はサンプル用に低く設定されている）
$cf{m_max} = 4;

# 投稿があるとメール通知する (sendmail必須)
# 0 : 通知しない
# 1 : 通知する
$cf{mailing} = 0;

# メールアドレス(メール通知する時)
$cf{mailto} = 'xxx@xxx.xx';

# sendmailパス（メール通知する時）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# 文字色の設定
# →　スペースで区切る
$cf{colors} = '#626063 #898989 #c9caca #e3acae #e95464 #68a4d9 #8d93c8 #79c06e #618e34 #fcc800 #f39800 #98605e #47266e #a688bd     ';

# 枠色の設定（半角スペースで区切る）
$cf{colors_b} = '#7a99cf #a2c2e6 #8d93c8 #0073a8 #008db7 #f7b977 #ee7800 #e5a323 #f39800 #79c06e #417038 #5f6527 #98605e #941f57 #ea5550 #ef857d #47266e #a688bd #6c2463 #da81b2 #f3a68c #e95464 #e3acae #c9caca #898989';

$cf{colors_b2}= 'ヒヤシンスブルー ベイビーブルー ウイスタリア エジプシャンブルー セルリアンブルー アプリコット オレンジ パンプキン マリーゴールド スペアミント スピナッチグリーン オリーブグリーン ココアブラウン クラレット レッド コーラルレッド ディープロイヤルパープル ラベンダーモーブ プラム オーキッドピンク サーモンピンク ローズ ピンクアーモンド シルバー バトルシップグレイ';

# URLの自動リンク (0=no 1=yes)
$cf{autolink} = 1;

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 0;

# アクセス制限（半角スペースで区切る、アスタリスク可）
# → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{deny_host} = '';
# → 拒否IPアドレスを記述（前方一致）【例】210.12.345.*
$cf{deny_addr} = '';

# アップロードを許可するファイル（0=no 1=yes）
$cf{ok_text}  = 0;  # TEXT
$cf{ok_gif}   = 1;  # GIF
$cf{ok_jpeg}  = 1;  # JPEG
$cf{ok_excel} = 1;  # EXCEL
$cf{ok_word}  = 1;  # WORD
$cf{ok_ppt}   = 0;  # POWER POINT
$cf{ok_zip}   = 1;  # ZIP
$cf{ok_pdf}   = 0;  # PDF
$cf{ok_png}   = 1;  # PNG
$cf{ok_mp3}   = 1;  # mp3
$cf{ok_mp4}   = 1;  # MP4

# アイコン定義
# → 拡張子とファイル名のペア
$cf{icons} = {
	'.pdf'  => 'pdf.png',
	'.doc'  => 'word.png',
	'.docx' => 'Word-icon.png',
	'.xls'  => 'excel.png',
	'.xlsx' => 'Excel-icon.png',
	'.ppt'  => 'ppt.png',
	'.pptx' => 'powerpoint.png',
	'.txt'  => 'text.png',
	'.zip'  => 'zip.png',
	'.mp3'  => 'mp3.png',
	'.mp4'  => 'mp4.png',
};

# 添付ファイルアイコンディレクトリ【URLパス】
$cf{atturl} = './cmn/icon';

# １回当りの最大投稿サイズ (bytes)
$cf{maxdata} = 51200000;

# 画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{max_img_w} = 250;
$cf{max_img_h} = 140;

# 登録アイコンファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{ico_max_img_w} = 48;
$cf{ico_max_img_h} = 48;

# 記事の更新は method=POST 限定する場合（セキュリティ対策）
# → 0=no 1=yes
$cf{postonly} = 1;

# 投稿制限（セキュリティ対策）
# 0 : しない
# 1 : 同一IPアドレスからの投稿間隔を制限する
# 2 : 全ての投稿間隔を制限する
$cf{regCtl} = 1;

# 制限投稿間隔（秒数）
# → $cf{regCtl} での投稿間隔
$cf{wait} = 60;

# 禁止ワード
# → コンマで区切って複数指定（例）$cf{no_word} = 'アダルト,出会い';
$cf{no_wd} = '';

# 日本語チェック（投稿時日本語が含まれていなければ拒否する）
# 0=No  1=Yes
$cf{jp_wd} = 1;

# URL個数チェック
# → 投稿コメント中に含まれるURL個数の最大値
$cf{urlnum} = 2;

# クッキーID名（特に変更しなくてよい）
$cf{cookie_id}  = "yyboard";  # フォーム入力
$cf{cookie_id3} = "yybpass";  # アクセス制限

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# -------------------------------------------------------------- #
# [ 以下は「過去ログ」機能を使用する場合の設定 ]
#
# 過去ログ生成
# → 0=no 1=yes
$cf{pastkey} = 1;

# 過去ログ用NOファイル【サーバパス】
$cf{nofile}  = './data/pastno.dat';

# 過去ログのディレクトリ【サーバパス】
# → パスの最後に / をつけない
$cf{pastdir} = './data/past';

# 過去ログ１ファイルの行数
# → この行数を超えると次ページを自動生成します
$cf{pastmax} = 600;

# -------------------------------------------------------------- #
# [ 以下は「投稿キー」の機能を使用する場合の設定 ]
# 画像認証コード入力フィールドに入力して｛表示される画像認証キーはダミーになります｝使用するため、
# 使用出来るキーは「数字」のみとなります

# 投稿キー機能の使用
# 画像認証機能はそのままで、投稿キーを優先する場合
# # 0=no 1=yes
$cf{postkey_reg} = 0;

# 投稿キー設定
# 画像認証機能の「投稿キーの文字数 $cf{cap_len} = 6;」と同じ桁数にする事
# 上記の例では「6」桁になります
$cf{postkey} = '123456';

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 2;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captyyboard';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "stamp.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "dejavusans.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# フォルダーアイコン
$cf{fld_icon} = {
	1 => 'neo.png',
	image => 'images.png',
	tube => 'youtube.png',
	resadd => 'res.png',
	};

# アイコン追加
push(@{$cf{icon}},"$cf{my_gif},管理者用") if ($cf{my_icon});

# 設定内容を返す
sub set_init { return %cf; }

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if ($_ ne 'upfile') {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行変換
			$val =~ s|\r\n|<br />|g;
			$val =~ s|[\n\r]|<br />|g;
		}

		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;
	
	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);
	
	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  パスワード制限
#-----------------------------------------------------------
sub passwd {
	my %in = @_;
	
	# 入室フォーム指定のとき
	if ($in{mode} eq 'enter') { pwd_form(); }
	
	# 時間取得
	my $now = time;
	
	# ログインのとき
	if ($in{login}) {
		# 認証
		if ($in{pw} ne $cf{enter_pwd}) { error("認証できません"); }
		
		# セッション発行
		my @wd = (0 .. 9, 'a' .. 'z', 'A' .. 'Z', '_');
		my $ses;
		for (1 .. 25) {	$ses .= $wd[int(rand(@wd))]; }
		
		# セッション更新
		my @log;
		open(DAT,"+< $cf{sesfile}") or error("open err: $cf{sesfile}");
		eval 'flock(DAT,2);';
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);
			next if ($now - $time > $cf{sestime} * 60);
			
			push(@log,"$_\n");
		}
		unshift(@log,"$ses\t$now\n");
		seek(DAT,0,0);
		print DAT @log;
		truncate(DAT,tell(DAT));
		close(DAT);
		
		# クッキー格納
		print "Set-Cookie: $cf{cookie_id3}=$ses\n";
	
	# セッション確認
	} else {
		
		# クッキー取得
		my $cook = $ENV{HTTP_COOKIE};
		
		# 該当IDを取り出す
		my %cook;
		foreach ( split(/;/,$cook) ) {
			my ($key,$val) = split(/=/);
			$key =~ s/\s//g;
			$cook{$key} = $val;
		}
		
		# クッキーなし
		if ($cook{$cf{cookie_id3}} eq '') { pwd_form(); }
		
		# ログオフのとき
		if ($in{mode} eq 'logoff') {
			
			my @log;
			open(DAT,"+< $cf{sesfile}") or error("open err: $cf{sesfile}");
			eval 'flock(DAT,2);';
			while(<DAT>) {
				my ($id,undef) = split(/\t/);
				next if ($cook{$cf{cookie_id3}} eq $id);
				
				push(@log,$_);
			}
			seek(DAT,0,0);
			print DAT @log;
			truncate(DAT,tell(DAT));
			close(DAT);
			
			if ($ENV{PERLXS} eq "PerlIS") {
				print "HTTP/1.0 302 Temporary Redirection\r\n";
				print "Content-type: text/html\n";
			}
			print "Set-Cookie: $cf{cookie_id3}=;\n";
			print "Location: $cf{homepage}\n\n";
			exit;
		}
		
		# セッションチェック
		my $flg;
		open(DAT,"$cf{sesfile}") or error("open err: $cf{sesfile}");
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);
			
			if ($cook{$cf{cookie_id3}} eq $id) {
				# 時間オーバー
				if ($now - $time > $cf{sestime} * 60) {
					$flg = -1;
				# OK
				} else {
					$flg = 1;
				}
				last;
			}
		}
		close(DAT);
		
		# 時間オーバー
		if ($flg == -1) {
			my $msg = qq|入室時間が経過しました。再度ログインしてください<br>\n|;
			$msg .= qq|[<a href="$cf{bbs_cgi}?mode=enter">ログイン</a>]\n|;
			error($msg);
		
		# セッション情報なし
		} elsif (!$flg) {
			pwd_form();
		}
	}
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub pwd_form {
	open(IN,"$cf{tmpldir}/enter.html") or error('open err: enter.html');
	my $tmpl = join('', <IN>);
	close(IN);
	
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	footer($tmpl,'pform');
}

#-----------------------------------------------------------
#  画像リサイズ
#-----------------------------------------------------------
sub resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{max_img_w} || $h > $cf{max_img_h}) {
		my $w2 = $cf{max_img_w} / $w;
		my $h2 = $cf{max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}
	return ($w,$h);
}

#-----------------------------------------------------------
#  ユーザー登録アイコン画像リサイズ
#-----------------------------------------------------------
sub ico_resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{ico_max_img_w} || $h > $cf{ico_max_img_h}) {
		my $w2 = $cf{ico_max_img_w} / $w;
		my $h2 = $cf{ico_max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}
	return ($w,$h);
}

1;

